%% Initialize system parameters
close all;clear all;clc;
%% Values
l_w = 0.33;             %[m]
l_p = 0.185;            %[m]
m_p = 0.033;            %[kg]
I_p = (m_p*l_p^2)/3;    %[kg m^2]
m_w = 0.088+0.5;        %[kg]
I_w = 0.088*0.055^2;    %[kg m^2]

g0 = 9.81;              %[m/s^2]
m0 = (m_p*l_p + m_w*l_w)*g0;

M_11 = m_p*l_p^2 + m_w*l_w^2 + I_p + I_w;
M_12 = I_w;
M_21 = I_w;
M_22 = I_w;

detM = M_11*M_22 - M_12*M_21;

K_m = 5.5e-3;
T_max = 0.6;

%% PID Controller
K_p = 1200;%2000;
K_i = inf;%0.5;
K_d = 0.75;

K_p_w = 0.2;

%% State-Space Equations
A = [0 1 0;
     (M_22*m0)/detM 0 0;
     -(M_21*m0)/detM 0 0];
B = [0; -M_12/detM; M_11/detM];
C = [0 1 0;
     0 0 1];
D = 0;

%% Linear Quadratic Control
Ql = [1 0 0;
      0 0.8 0;
      0 0 0.6];
Rl = 1;
Nl = 0;

[Kl,Sl,el] = lqr(A,B,Ql,Rl,Nl);

%% Initial Conditions
x11_0 = pi/20;
x12_0 = -pi/30;
x2_0 = 0;
x3_0 = 0;
